<template>
    <div style="min-width: 60vw; max-width: 60vw;">
        <q-expansion-item expand-separator icon="inventory2" :label="scoop_package?.name"
            :caption="scoop_package?.version" expand-icon-toggle>
            <template #header>
                <q-item-section avatar>
                    <q-avatar icon="inventory2" size="xl" />
                </q-item-section>
                <q-item-section>
                    <div v-if="has_cat_result(c => c.homepage)">
                        <a :href="cat_result()?.homepage" target="_blank">
                            {{ scoop_package?.name }}
                        </a>
                    </div>
                    <div v-else>
                        {{ scoop_package?.name }}
                    </div>
                    <div v-if="scoop_package?.additional_info?.cat?.on_success?.description">
                        <sub style="opacity: 0.5;">{{
                                scoop_package?.additional_info?.cat?.on_success?.description
                        }}</sub>
                    </div>
                </q-item-section>
                <q-item-section side v-if="is_downloaded">
                    <q-btn flat icon="upgrade" @click="upgrade_package" />
                    <q-btn flat icon="delete" @click="delete_package" />
                </q-item-section>
                <q-item-section side v-else>
                    <q-btn flat icon="download" @click="download_package" />
                </q-item-section>
            </template>
            <q-separator />
            <q-card>
                <q-card-section>
                    <q-list>
                        <q-item v-if="has_cat_result(c => c.version)">
                            <q-item-section avatar>
                                <q-chip>
                                    <q-avatar icon="newspaper" size="xl" />
                                    Version
                                </q-chip>
                            </q-item-section>
                            <q-item-section>
                                {{ cat_result()?.version }}
                            </q-item-section>
                        </q-item>
                        <q-item v-if="has_cat_result(c => c.license)">
                            <q-item-section avatar>
                                <q-chip>
                                    <q-avatar icon="account_balance" size="xl" />
                                    License(s)
                                </q-chip>
                            </q-item-section>
                            <q-item-section>
                                <a v-for="(license, index) in cat_result()?.license.split('|')" :key="index"
                                    :href="tldr_license_link(license)" target="_blank">{{ license }}</a>
                            </q-item-section>
                        </q-item>
                        <q-item v-if="has_info_result(i => i.Bucket)">
                            <q-item-section avatar>
                                <q-chip>
                                    <q-avatar icon="local_cafe" size="xl" />
                                    Bucket
                                </q-chip>
                            </q-item-section>
                            <q-item-section>
                                {{ info_result()?.Bucket }}
                            </q-item-section>
                        </q-item>
                    </q-list>
                </q-card-section>
            </q-card>
        </q-expansion-item>
        <q-separator />

    </div>
</template>

<script lang="ts">
import { invoke } from '@tauri-apps/api'
import { defineComponent, onMounted, PropType, ref } from 'vue'
import * as ST from './models'

export default defineComponent({
    props: {
        scoop_package: Object as PropType<ST.ScoopSearchResult>,
    },
    data() {
        return {
            tldrlegal_map: {
                'MIT': 'mit-license',
                'Apache-2.0': 'apache-license-2.0-(apache-2.0)',
                'MPL-2.0': 'mozilla-public-license-2.0-(mpl-2)',
            }
        }
    },
    setup(props) {
        const is_downloaded = ref(false)

        onMounted(async () => {
            is_downloaded.value = await invoke('is_downloaded', { packageName: props.scoop_package?.name })
        })

        return { is_downloaded }
    },

    methods: {
        async download_package() {
            await this.invoke_pkg('download_package')
        },
        async upgrade_package() {
            await this.invoke_pkg('upgrade_package')
        },
        async delete_package() {
            await this.invoke_pkg('delete_package')
        },
        async invoke_pkg(invoke_name: string) {
            await invoke(invoke_name, { packageName: this.scoop_package?.name })
        },
        has_cat_result<T>(prop_map: (input: ST.ScoopCatResult) => T): boolean {
            const cat_result = this.cat_result()

            if (!cat_result)
                return false

            return prop_map(cat_result) !== undefined
        },
        has_info_result<T>(prop_map: (input: ST.ScoopInfoResult) => T): boolean {
            const info_result = this.info_result()

            if (!info_result)
                return false

            return prop_map(info_result) !== undefined
        },
        cat_result(): ST.ScoopCatResult | undefined {
            return this.scoop_package?.additional_info.cat?.on_success
        },
        info_result(): ST.ScoopInfoResult | undefined {
            return this.scoop_package?.additional_info.info?.on_success
        },

        tldr_license_link(pkg_license_name: string): string {
            return `https://tldrlegal.com/license/${this.tldrlegal_map[pkg_license_name]}`
        },
        is_last<T>(index: number, list?: T[]): boolean {
            if (!list) {
                return false
            }

            return index >= list.length
        }
    }
})
</script>

<style scoped>
</style>